﻿using CommunityToolkit.Mvvm.ComponentModel;
using RenderableSeriesViewModel.Models;
using SciChart.Charting.Model.ChartSeries;
using SciChart.Data.Model;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace RenderableSeriesViewModel.ViewModels
{
    //ViewModel shared with other ViewModels used to declare properties

    public partial class SharedViewModel : ObservableObject
    {
        // define properties

        [ObservableProperty]
        // define a property to hold the file path
        public string? filePath;

        [ObservableProperty]
        public List<TaggedData> series;

        [ObservableProperty]
        // define a property to hold the list of renderable series
        public ObservableCollection<LineRenderableSeriesViewModel> renderableSeriesViewModels;

        [ObservableProperty]
        // define a property to hold the chart title
        public string? chartTitle;

        [ObservableProperty]
        // define a property to hold the x axis title
        public string xAxisTitle = "TIME";

        [ObservableProperty]
        public bool isDigitalLine = false;

        [ObservableProperty]
        // define a property to hold the list of y axes
        public ObservableCollection<IAxisViewModel> yAxes;

        [ObservableProperty]
        // define a property to hold the x axis visible range
        public DateRange? xVisibleRange;

        [ObservableProperty]
        public string fontSizeRollOver = "12";

        [ObservableProperty]
        public string opacityRollOver = ".7";

        [ObservableProperty]
        public string fontSizeLegend = "12";

        [ObservableProperty]
        public string lineSpacingLegend = "10";

    }
}
